LeetCode 452. Minimum Number of Arrows to Burst Balloons 用最少数量的箭引爆气球(贪心问题)

本文介绍了LeetCode 452题目的详细解题过程,该题为"Minimum Number of Arrows to Burst Balloons",即如何用最少数量的箭来射爆所有二维空间内的气球。文章通过举例说明问题,然后提出采用贪心策略,先按气球右边界排序,从左向右依次判断,确保每一箭都能射穿尽可能多的气球。并给出了对应的解题代码。
摘要由CSDN通过智能技术生成

LeetCode 452. Minimum Number of Arrows to Burst Balloons 用最少数量的箭引爆气球

452. Minimum Number of Arrows to Burst Balloons 用最少数量的箭引爆气球

Description:

There are a number of spherical balloons spread in two-dimensional space. For each balloon, provided input is the start and end coordinates of the horizontal diameter. Since it’s horizontal, y-coordinates don’t matter and hence the x-coordinates of start and end of the diameter suffice. Start is always smaller than end. There will be at most 104 balloons.

An arrow can be shot up exactly vertically from different points along the x-axis. A balloon with xstart and xend bursts by an arrow shot at x if xstart ≤ x ≤ xend. There is no limit to the number of arrows that can be shot. An arrow once shot keeps travelling up infinitely. The problem is to find the minimum number of arrows that must be shot to burst all balloons.

Example:

Example:

Input:
[[10,16], [2,8], [1,6], [7,12]]

Output:
2

Explanation:
One way is to shoot one arrow for example at x = 6 (bursting the balloons [2,8] and [1,6]) and another arrow at x = 11 (bursting the other two balloons).

解答

这是一道贪心问题,我们每次戳破气球的时候都要尽可能的戳破更多的气球。

怎么样才能尽可能戳破更多的气球呢?

我们可以先按照气球的右坐标进行从小到大排序。从第二个气球开始,只要第二个气球的左坐标小于第一个气球的右坐标ÿ

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值